# Template job similar to Gitlab's build in SAST job, but works with our auto-scaling Docker executors

sast:
  stage: test
  tags:
    - autoscaling
    - docker-compose
  image: thelab/dind:latest
  allow_failure: true
  script:
    - export SAST_VERSION=${SP_VERSION:-$(echo "$CI_SERVER_VERSION" | sed 's/^\([0-9]*\)\.\([0-9]*\).*/\1-\2-stable/')}

    - export CONTAINER_ID=$(cat /proc/1/cgroup | grep 'docker/' | tail -1 | sed 's/^.*\///' | cut -c 1-12)

    # This is required to avoid undesirable reset of Docker image ENV variables being set on build stage
    - |
      function propagate_env_vars() {
        CURRENT_ENV=$(printenv)

        for VAR_NAME; do
          echo $CURRENT_ENV | grep "${VAR_NAME}=" > /dev/null && echo "--env $VAR_NAME "
        done
      }

    # Run the SAST tests
    - |
      docker run \
        $(propagate_env_vars \
          SAST_ANALYZER_IMAGES \
          SAST_ANALYZER_IMAGE_PREFIX \
          SAST_ANALYZER_IMAGE_TAG \
          SAST_DEFAULT_ANALYZERS \
          SAST_EXCLUDED_PATHS \
          SAST_BANDIT_EXCLUDED_PATHS \
          SAST_BRAKEMAN_LEVEL \
          SAST_GOSEC_LEVEL \
          SAST_FLAWFINDER_LEVEL \
          SAST_DOCKER_CLIENT_NEGOTIATION_TIMEOUT \
          SAST_PULL_ANALYZER_IMAGE_TIMEOUT \
          SAST_RUN_ANALYZER_TIMEOUT \
        ) \
        --volumes-from ${CONTAINER_ID} \
        --volume /var/run/docker.sock:/var/run/docker.sock \
        "registry.gitlab.com/gitlab-org/security-products/sast:$SAST_VERSION" /app/bin/run $(pwd)

    # Upload the report
    - if [ ! -z "${SAST_REPORT_UPLOAD_URL}" ]; then
        curl -F "project_name=$CI_PROJECT_PATH" -F "branch_name=$CI_COMMIT_REF_NAME" -F "report_file=@gl-sast-report.json" "${SAST_REPORT_UPLOAD_URL}";
      fi

  artifacts:
    paths:
      - ./gl-sast-report.json
    # reports:
    #   sast: gl-sast-report.json
  dependencies: []
  only:
    refs:
      - branches
